#!/usr/bin/python

import logging
import ConfigParser

class BluebagConfig:
    def __init__(self):        
        
        config_fp = open('../etc/BluebagConfig.ini');
        config = ConfigParser.SafeConfigParser();
        config.readfp(config_fp);
        config_fp.close();

        #[TASK]
        self.task_ = config.get("TASK","task");
        self.taskTag_ = config.get("TASK","taskTag");
        self.tagWithTimestamp_ = config.getboolean("TASK","tagWithTimestamp");
        self.sessionLength_ = config.getint("TASK","sessionLength");
        self.shutdown_ = config.getboolean("TASK","shutdown");
        self.humanAckAddresses_ = config.get("TASK","humanAckAddresses").split(',');
        
        #[DIRS]
        self.dbDir_ = config.get("DIRS","dbDir");
        self.logDir_ = config.get("DIRS","logDir");
        self.toolDir_ = config.get("TOOLS","toolDir");
        
        #[DATABASE]
        self.dbName_ = config.get("DATABASE","dbName");
        self.dbType_ = config.get("DATABASE","dbType");
        self.dbSocket_ = config.get("DATABASE","dbSocket");
        self.dbUser_ = config.get("DATABASE","dbUser");
        self.dbPassword_ = config.get("DATABASE","dbPassword");
        
        #[LOGGING]
        self.logFilename_ = config.get("LOGGING","logFilename");
        level = config.get("LOGGING","logLevel");
        self.logLevel_ = logging.DEBUG;
        if level == "INFO":
          self.logLevel_ = logging.INFO;
        elif level == "WARNING":
          self.logLevel_ = logging.WARNING;
        elif level == "ERROR":
          self.logLevel_ = logging.ERROR;
        elif level == "FATAL":
          self.logLevel_ = logging.FATAL;
        elif level == "DEBUG":
          self.logLevel_ = logging.DEBUG;
        level = config.get("LOGGING","consoleLogLevel");
        self.consoleLogLevel_ = logging.DEBUG;
        if level == "INFO":
          self.consoleLogLevel_ = logging.INFO;
        elif level == "WARNING":
          self.consoleLogLevel_ = logging.WARNING;
        elif level == "ERROR":
          self.consoleLogLevel_ = logging.ERROR;
        elif level == "FATAL":
          self.consoleLogLevel_ = logging.FATAL;
        elif level == "DEBUG":
          self.consoleLogLevel_ = logging.DEBUG;          
        
        #[TOOLS]
        self.redPath_ = config.get("TOOLS","redPath");
        self.hciconfigPath_ = config.get("TOOLS","hciconfigPath");
        self.hcitoolPath_ = config.get("TOOLS","hcitoolPath");
        self.sdptoolPath_ = config.get("TOOLS","sdptoolPath");
        self.btobexPath_ = config.get("TOOLS","btobexPath");
        self.bnepScript_ = config.get("TOOLS","bnepScript");
        
        #[DONGLES]
        self.scanDelay_ = config.getint("DONGLES","scanDelay");
        self.autoDetectDongles_ = config.getboolean("DONGLES","autoDetectDongles");
        self.numDongles_ = config.getint("DONGLES","numDongles");
        self.scanReservedDongle_ = config.get("DONGLES","scanReservedDongle");
        self.reservedDongles_ = config.get("DONGLES","reservedDongles").split(',');
        self.ignoreDevices_ = config.get("DONGLES","ignoreDevices").split(',');
        
        #[SURVEY]
        self.simulateDevices_ = config.getboolean("SURVEY","simulateDevices");
        self.simulationBaseAddress_ = config.get("SURVEY","simulationBaseAddress");

        #[STUPID]
        self.stupidMaxRetry_ = config.getint("STUPID","maxRetry");
        
        #[BRUTE]
        self.fangDefaultRangeWidth_ = config.getint("BRUTE","fangDefaultRangeWidth");
        self.fangDefaultCenterAddress_ = config.get("BRUTE","fangDefaultCenterAddress");
        self.stopWhenFound_ = config.getboolean("BRUTE","stopWhenFound");
        
        #[WORM]
        self.limitInfection_ = config.getboolean("WORM","limitInfection");
        self.quarantineDevices_ = config.get("WORM","quarantineDevices").split(',');
        self.maxChildWorm_ = config.getint("WORM","maxChildWorm");
        self.transport_ = config.get("WORM","transport");
